STEP1_Retros_VPA_ICCAT_wps <- function(wps_uri,
                         username,
                         token,
                         process_id,
                         Year_Assessment,
                         runNumb_retros,seedNumb_retros,
                         filenameVpa,
                         nbRetro_retros,nbBoot_retros,
                         get_all_retros,run_to_get,
                         seed_number_to_get,
                         what_data,catch_type){
  
  #SAMPLE DESCRIPTION OF THE ALGORITHM IS HERE: 
  #http://dataminer1-d-d4s.d4science.org/wps/WebProcessingService?Request=DescribeProcess&Service=WPS&Version=1.0.0&gcube-token=4ccc2c35-60c9-4c9b-9800-616538d5d48b&Identifier=org.gcube.dataanalysis.wps.statisticalmanager.synchserver.mappedclasses.transducerers.ICHTHYOP_MODEL_ONE_BY_ONE
  
  #source("WPS4D4Science.R")
  #SERVICE PARAMETERS
  #wps_uri = "http://dataminer1-d-d4s.d4science.org:80/wps/WebProcessingService" #DEV "http://dataminer1-d-d4s.d4science.org:80/wps/WebProcessingService"
  #username<-"statistical.wps"
  #token<-"45943442-74ef-408b-be64-d26b42cf4c08"
  
  #rm(list=ls())
  print("So far so good 1")
  
  options(digits.secs=3)
  
  
  #TEMPLATE TO FULFILL TO INVOKE THE ALGORITHM#
  ###???????creat template
#   templateFile="../configuration_files/TemplateIchtyopRequest.xml";
#   templateFile="/home/taha/Projets/BlueBridge_Ichtyop/ichthyop/configuration_files/TemplateIchtyopRequest.xml"
  templateFile=paste(dirMain,"TemplateIVPARetrosRequest.xml",sep="")
  #CREATE NEW ON-THE-FLY VERSION OF THE TEMPLATE#
  sentfile=paste("BFTE_Retros_req_",Sys.time(),".xml",sep="")
  sentfile<-gsub(":", "_", sentfile)
  sentfile<-gsub(":", "_", sentfile)
  sentfile<-gsub(" ", "_", sentfile)
  
  filexml<-readChar(templateFile, file.info(templateFile)$size)
  filexml<-gsub("\r\n", "\n", filexml)
  
  #FULFILL THE TEMPLATE#
  filexml<-gsub("#Year_Assessment#", Year_Assessment, filexml)
  filexml<-gsub("#runNumb_retros#", runNumb_retros, filexml)
  filexml<-gsub("#seedNumb_retros#", seedNumb_retros, filexml)
  filexml<-gsub("#filenameVpa#", filenameVpa, filexml)
  filexml<-gsub("#nbRetro_retros#", nbRetro_retros, filexml)
  filexml<-gsub("#nbBoot_retros#", nbBoot_retros, filexml)
  filexml<-gsub("#get_all_retros#", get_all_retros, filexml)
  filexml<-gsub("#run_to_get#", run_to_get, filexml)
  filexml<-gsub("#seed_number_to_get#", seed_number_to_get, filexml)
  filexml<-gsub("#what_data#", what_data, filexml)
  filexml<-gsub("#catch_type#", catch_type, filexml)
  
  
  print("write XML for DescribeProcess query")
  
  filehandle <- file(filexml)
  write(filexml, file = sentfile,append = FALSE, sep = "")
  close(filehandle)
  
  #CALL WPS VIA POST#
  out<-POST(url = wps_uri, config=c(authenticate(username, token, type = "basic")),body = upload_file(sentfile, type="text/xml"),encode = c("multipart"), handle = NULL, timeout(3600))
  
  ###ALTERNATIVE CALL FOR FAST TESTING###
  #testURL<-"http://dataminer-d-d4s.d4science.org/wps/WebProcessingService?request=Execute&service=WPS&Version=1.0.0&gcube-token=4ccc2c35-60c9-4c9b-9800-616538d5d48b&lang=en-US&Identifier=org.gcube.dataanalysis.wps.statisticalmanager.synchserver.mappedclasses.modellers.FEED_FORWARD_ANN&storeExecuteResponse=true&lineage=true&status=true&DataInputs=TrainingDataSet=http://data-d.d4science.org/UndsT051bEZwbEpnRzM4WHQ3RWVlVDQ0eHNITWgzRXdHbWJQNStIS0N6Yz0;TrainingColumns=a|b;TargetColumn=t;LayersNeurons=1;Reference=1;LearningThreshold=0.01;MaxIterations=100;ModelName=neuralnet_;"
  #out<-GET(url = testURL, config=c(authenticate(username, token, type = "basic")),handle = NULL, timeout(3600))
  #out1<-out
  
  #CHECK IF THE PROCESS HAS ALREADY FINISHED#
  stop_condition_success<-grepl("Process successful",as.character(out))
  stop_condition_fail<-grepl("Exception",as.character(out))
  
  #GET THE STATUS LOCATION FROM THE ACCEPTANCE RESPONSE#
  lout<-as.character(out)
  print(lout)
  
  write(lout, file = "log.txt",append = TRUE, sep = " ")
  
  statusLocation='statusLocation=\"'
  endstatusLocation='">\n'
  pos1 = regexpr(statusLocation, lout)
  pos2 = regexpr(endstatusLocation, lout)
  llout<-substr(lout, pos1+nchar(statusLocation), pos2-1)
  print(llout)
  
  count <- 0
  #CHECK THE STATUS OF THE COMPUTATION UNTIL COMPLETION#
  timeTestStart <- Sys.time()
  
  while (!stop_condition_fail && !stop_condition_success){
    message=paste("Checking every 10 seconds while processing is not over: ",count," seconds",sep="")
    cat(message)
    #CHECK THE STATUS URL#
    out1<-GET(url = llout, config=c(authenticate(username, token, type = "basic")),handle = NULL, timeout(3600))
    
    print(as.character(out1))
    stop_condition_success<-grepl("ProcessSucceeded",as.character(out1))
    stop_condition_fail<-grepl("Exception",as.character(out1))
    if (!stop_condition_fail) 
      stop_condition_fail<-grepl("temporarily unavailable",as.character(out1))
    
    #SLEEP FOR 10 SECONDS BEFORE THE NEXT CHECK#
    Sys.sleep(10)
    count <- count + 10
  }
  
  timeTestEnd <- Sys.time()
  ExecutionTime <- timeTestEnd - timeTestStart
  message=paste("Execution of the process took: ",ExecutionTime," seconds",sep="")
  
  write(message, file = "log.txt",append = TRUE, sep = " ")
  
  print(as.character(out1))
  
  write(as.character(out1), file = "log.txt",append = TRUE, sep = " ")
  
  if (stop_condition_success){
    print("get Response XML before error1")
    #PARSE THE OUTPUT IN THE CASE OF SUCCESS
    wps.output<-parseResponse(response=out1)
    print("get Response XML before error2")
    output<-as.data.frame(wps.output)
    print("get Response XML before error3")
    #View(output)
    print("begin print output")
    print("get Response XML after error")
    #print(output)
    print("URL: ")
    #print(output$Value)
    print("end print output")
    
  }
  
  #closeAllConnections()
  
    print("begin return output to main code")
  if(!(exists('output'))){output=data.frame(value=NA)
  }else{return (output)}
  print("end return output to main code")
  
}

