
#########################################################################################
### Function to extract weigth-at-age from Yield-at-age and catch-at-age (version 1)  ###
#########################################################################################
waa_age_plus_v1 <- function(age_minus,age_plus, file, id_new){
  if ((file%in%c(paste(dirData, "fecaa.csv", sep="")))==T){
    waa_final      <- read.table(file, sep=";")
    colnames(waa_final) <- c("Year", 1:(dim(waa_final)[2]-1))
  } else if ((file%in%c(paste(dirData, "fecaa2012.csv", sep="")))==T){
    waa_final      <- read.table(file, sep=";")
    colnames(waa_final) <- c("Year", 1:(dim(waa_final)[2]-1))
  } else {  
  if (id_new ==0){total_yaa        <- read.table(paste(dirData,'YAA_full.csv', sep=""), header=T, sep=",")}  
  if (id_new ==1){total_yaa        <- read.table(paste(dirData,'YAA_full_new.csv', sep=""), header=T, sep=",")} 
  
  sub_tot_yaa      <- subset(total_yaa, subset=(total_yaa$StockID%in%c("ATE", "MED")))
  sub_tot_yaa_melt <- melt(sub_tot_yaa, measure.vars=colnames(sub_tot_yaa)[23:48]) 
  
  if (id_new ==0){total_caa        <- read.table(paste(dirData,'CAA_full.csv', sep=""), header=T, sep=",")}
  if (id_new ==1){total_caa        <- read.table(paste(dirData,'CAA_full_new.csv', sep=""), header=T, sep=",")}
  sub_tot_caa      <- subset(total_caa, subset=(total_caa$StockID%in%c("ATE", "MED")))
  sub_tot_caa_melt <- melt(sub_tot_caa, measure.vars=colnames(sub_tot_caa)[23:48]) 
  
  total_waa        <- data.frame(Year=sub_tot_caa_melt$YearC,
                                 Age=sub_tot_caa_melt$variable,
                                 CAA=sub_tot_caa_melt$value,
                                 YAA=sub_tot_yaa_melt$value)
  
  total_waa1       <- total_waa[which(total_waa$CAA>0),]
  total_waa1$Age   <- as.numeric(substr(total_waa1$Age, 4,6))
  
  sub_ageplus_1    <- subset(total_waa1, subset=c(total_waa1$Age<age_plus & total_waa1$Age>age_minus))
  waa_final1       <- ddply(sub_ageplus_1, .(Year,Age), function(x) data.frame(WAA=sum(x$YAA)/sum(x$CAA)))
  if (age_minus>0){
    sub_ageminus_3  <- subset(total_waa1, subset=c(total_waa1$Age<=age_minus))
    waa_final_minus <- ddply(sub_ageminus_3, .(Year), function(x) data.frame(Age=age_minus,WAA=sum(x$YAA)/sum(x$CAA)))
  } else {waa_final_minus=NULL}
  sub_ageplus_2     <- subset(total_waa1, subset=c(total_waa1$Age>=age_plus))
  waa_final2        <- ddply(sub_ageplus_2, .(Year), function(x) data.frame(Age=age_plus,WAA=sum(x$YAA)/sum(x$CAA)))
  waa_final         <- data.frame(rbind(waa_final_minus,waa_final1, waa_final2))
  waa_final         <- cast(waa_final, Year~Age)
  waa_final[is.na(waa_final[,2]),2] <- (waa_final[(which(is.na(waa_final[,2])==T)-1),2]+waa_final[(which(is.na(waa_final[,2])==T)+1),2])/2
  }
  return(waa_final)
}

#########################################################################################
### Function to extract weigth-at-age from Yield-at-age and catch-at-age (version 2)  ###
### TO BE DONE ONCE WE HAVE MAURICIO'S PROCEDURE                                      ###
#########################################################################################
waa_age_plus_v2 <- function(age_minus, age_plus){
  
  sub_ageplus_1      <- subset(total_waa1, subset=c(total_waa1$Age<age_plus))
  sub_ageplus_1$avrg <- sub_ageplus_1$YAA/sub_ageplus_1$CAA
  waa_final1         <- ddply(sub_ageplus_1, .(Year,Age), function(x) data.frame(WAA=mean(x$avrg)))
  sub_ageplus_2      <- subset(total_waa1, subset=c(total_waa1$Age>=age_plus))
  sub_ageplus_2$avrg <- sub_ageplus_2$YAA/sub_ageplus_2$CAA
  waa_final2         <- ddply(sub_ageplus_2, .(Year,Age), function(x) data.frame(WAA=(sum(x$YAA)/sum(x$CAA)),CAA=sum(x$CAA) ))
  waa_final3         <- ddply(waa_final2, .(Year), function(x) data.frame(Age=age_plus, WAA=mean(x$WAA)))
  waa_final          <- data.frame(rbind(waa_final1, waa_final3))
}

#########################################################################################
### Function to extract catch-at-age                                                  ###
#########################################################################################
caa_age_plus <- function(age_minus,age_plus, file){
  if (length(grep(pattern=file, x=paste(dirData, c("CAA2012.csv"), sep="") ))==1){
             caa_final           <- read.table(file, header=F, sep=";")
             colnames(caa_final) <- c("Year", 1:(dim(caa_final)[2]-1))
    }
  if (length(grep(pattern = file, x=paste(dirData, "CAA_inflated.csv", sep="")))==1){
    caa_final           <- read.table(file, header=F, sep=";")
    colnames(caa_final) <- c("Year", 1:(dim(caa_final)[2]-1))
  } 
  if ((file==paste(dirData, "CAA_Age1_25.csv", sep=""))==T) {
  total_caa                <- read.table(file, header=F, sep=";")
  colnames(total_caa)      <- c("Year", 1:(dim(total_caa)[2]-1))
  total_caa_melt           <- melt(total_caa,id="Year")
  colnames(total_caa_melt) <- c("Year", "Age", "value")
  total_caa_melt$Age       <- as.numeric(as.character(total_caa_melt$Age))
  ## get the CAA between age_minus and age_plus  
  sub_age_int              <- subset(total_caa_melt, subset=c(total_caa_melt$Age<age_plus & total_caa_melt$Age>age_minus))
  colnames(sub_age_int)[3] <- "CAA"
  if (age_minus>0){
    sub_ageminus_3         <- subset(total_caa_melt, subset=c(total_caa_melt$Age<=age_minus))
    sub_ageminus_final     <- ddply(sub_ageminus_3, .(Year), function(x) data.frame(Age=age_minus, CAA=sum(x$value)))
  } else {sub_ageminus_final=NULL}
  sub_ageplus_2            <- subset(total_caa_melt, subset=c(total_caa_melt$Age>=age_plus))
  sub_ageplus_final        <- ddply(sub_ageplus_2, .(Year), function(x) data.frame(Age=age_plus,CAA=sum(x$value)))
  caa_final                <- data.frame(rbind(sub_ageminus_final, sub_age_int, sub_ageplus_final))
  caa_final                <- cast(caa_final, Year~Age)
  }

  if ((file==paste(dirData, "CAA_Age1_25_new.csv", sep=""))==T) {
    total_caa                <- read.table(file, header=F, sep=";")
    colnames(total_caa)      <- c("Year", 1:(dim(total_caa)[2]-1))
    total_caa_melt           <- melt(total_caa,id="Year")
    colnames(total_caa_melt) <- c("Year", "Age", "value")
    total_caa_melt$Age       <- as.numeric(as.character(total_caa_melt$Age))
    ## get the CAA between age_minus and age_plus  
    sub_age_int              <- subset(total_caa_melt, subset=c(total_caa_melt$Age<age_plus & total_caa_melt$Age>age_minus))
    colnames(sub_age_int)[3] <- "CAA"
    if (age_minus>0){
      sub_ageminus_3         <- subset(total_caa_melt, subset=c(total_caa_melt$Age<=age_minus))
      sub_ageminus_final     <- ddply(sub_ageminus_3, .(Year), function(x) data.frame(Age=age_minus, CAA=sum(x$value)))
    } else {sub_ageminus_final=NULL}
    sub_ageplus_2            <- subset(total_caa_melt, subset=c(total_caa_melt$Age>=age_plus))
    sub_ageplus_final        <- ddply(sub_ageplus_2, .(Year), function(x) data.frame(Age=age_plus,CAA=sum(x$value)))
    caa_final                <- data.frame(rbind(sub_ageminus_final, sub_age_int, sub_ageplus_final))
    caa_final                <- cast(caa_final, Year~Age)
  }
  return(caa_final)
}

#########################################################################################
### Function to extract partial catch-at-age                                          ###
#########################################################################################
pcaa_age_plus <- function(age_minus,age_plus, file){

  if (file%in%paste(dirData,c("PCAA_Age1_25.csv","PCAA_Age1_25_mar.csv","PCAA_Age1_25_new.csv", "PCAA_inflated.csv", "PCAA_v1.csv", "PCAA_Age1_25_Run3.csv", "PCAA_Age1_25_Run3_new.csv"), sep="")==F){
    pcaa_final           <- read.table(file, header=F, sep=";")
    colnames(pcaa_final) <- c("CPUE_number", "Year", 1:(dim(pcaa_final)[2]-2))
  } 
  else{
    print(file)
    total_pcaa                <- read.table(file, header=F, sep=";")
    colnames(total_pcaa)      <- c("CPUE_number","Year", 1:(dim(total_pcaa)[2]-2))
    total_pcaa_melt           <- melt(total_pcaa,id=c("CPUE_number", "Year"))
    colnames(total_pcaa_melt) <- c("CPUE_number","Year", "Age", "value")
    total_pcaa_melt$Age       <- as.numeric(as.character(total_pcaa_melt$Age))
    ## get the CAA between age_minus and age_plus  
    sub_age_int               <- subset(total_pcaa_melt, subset=c(total_pcaa_melt$Age<age_plus & total_pcaa_melt$Age>age_minus))
    colnames(sub_age_int)[4]  <- "PCAA"
    if (age_minus>0){
      sub_ageminus_3          <- subset(total_pcaa_melt, subset=c(total_pcaa_melt$Age<=age_minus))
      sub_ageminus_final      <- ddply(sub_ageminus_3, .(CPUE_number, Year), function(x) data.frame(Age=age_minus, PCAA=sum(x$value)))
    } else {sub_ageminus_final=NULL}
    sub_ageplus_2             <- subset(total_pcaa_melt, subset=c(total_pcaa_melt$Age>=age_plus))
    sub_ageplus_final         <- ddply(sub_ageplus_2, .(CPUE_number, Year), function(x) data.frame(Age=age_plus,PCAA=sum(x$value)))
    pcaa_final                <- data.frame(rbind(sub_ageminus_final, sub_age_int, sub_ageplus_final))
    pcaa_final                <- cast(pcaa_final, CPUE_number+Year~Age)
  }
  return(pcaa_final)
}

