
######## create netcdf version 4
##################################
### from projection Rdata to NetCDF
####################################
#####################################
projOutput2NetCDF <- function(dirOut_nc,namenc,run_name,nbr_seed,projOutput_VPA){
  #--- DEBUT
  
  # packages
  library(ncdf4)
  #--- DEBUT
  # rm(list=ls())
  # load(data_projection_Run_1_911.Rdata)
  ####Create netCDF dimensions
  ############################
  # make Run and Seed as two first dimentions
#   run_name <- "Run_1"
#   nbr_seed <- 911
  
  Run <- run_name
  Seed <- nbr_seed
  
  unit=""
  for(k in 1:length(Run)){ unit <- paste(unit,paste(k,":",Run[k],sep=""),sep=" ")}
  
  #unlim T or F ??
  dimRun <- ncdim_def( name="RUN", units= unit, vals=1:length(Run),unlim = F)
  dimSeed <- ncdim_def( name="SEED", units= "num of seed", vals=Seed,unlim=F)
  
  
  ##for year dimension 
  YEAR <- as.numeric(unique(projOutput_VPA$year))
  dimYEAR <- ncdim_def( name="year", units= "nbre_year", vals=YEAR)
  
  ##for tac dimension 
  TAC <- as.numeric(unique(projOutput_VPA$tac))
  dimTAC <- ncdim_def( name="tac", units= "num_tac", vals=TAC)
  
  ##for Scenario dimension 
  Scen <-unique(projOutput_VPA$Scenario)
  SCENARIO <- 1:length(Scen)
  Scen1 <- as.character(Scen)
  for(p in Scen){
    ind <- match(p,Scen1)
    Scen1[ind]<- paste(ind,Scen1[ind],sep=":")
  }
  Scen1 <- paste(Scen1, collapse = ' ')
  dimSCENARIO <- ncdim_def("Scenario", units= Scen1, vals=SCENARIO)
  
  ##for iter dimension 
  ITER <- unique(projOutput_VPA$iter)
  dimITER <- ncdim_def( name="iter", units= "num_iter", vals=ITER)
  
  ##for f0.1 dimension 
  F0.1 <- unique(projOutput_VPA$f0.1)
  # dimF0.1 <- ncdim_def( name="f0.1", units= "", vals=F0.1)
  
  ##for ssb0.1 dimension 
  SSB0.1 <- unique(projOutput_VPA$ssb0.1)
  # dimSSB0.1 <- ncdim_def( name="ssb0.1", units= "", vals=SSB0.1)
  
  ##definition of variables
  
  nonAvailable <- NA
  STOCK <- ncvar_def(name="stock", units="", dim=list(dimRun,dimSeed,dimYEAR,dimTAC,dimSCENARIO,dimITER), missval=nonAvailable, prec="float")
  HARVEST <- ncvar_def(name="harvest", units="", dim=list(dimRun,dimSeed,dimYEAR,dimTAC,dimSCENARIO,dimITER), missval=nonAvailable, prec="float")
  F0.1 <- ncvar_def(name="f01", units="", dim=list(dimRun,dimSeed,dimSCENARIO,dimITER), missval=nonAvailable, prec="float")
  SSB0.1 <- ncvar_def(name="ssb01", units="", dim=list(dimRun,dimSeed,dimSCENARIO,dimITER), missval=nonAvailable, prec="float")
  # Create netCDF file (the same name of .Rdata)
  # ncName <- gsub("Rdata","nc",rdata_name)
  # ncName <- paste(dirOut_nc, "data_projection_", run_name, "_", nbr_seed,".nc", sep="" )
  ncName <- namenc
  nc <- nc_create(  paste(dirOut_nc,ncName,sep=""), list(STOCK,HARVEST,F0.1,SSB0.1),force_v4 = T)
  
  ##Put Variables
  data <- projOutput_VPA
  
  for(i in dimSCENARIO$vals){
    DATA1 <- subset(data,data$Scenario==Scen[i])
    for(j in 1:length(ITER)){
      DATA <- subset(DATA1,DATA1$iter==ITER[j])
      matSTOCK <- matrix(data = DATA$stock,nrow = length(unique(DATA$year)),ncol = length(unique(DATA$tac)))
      matHARVEST <- matrix(data = DATA$harvest,nrow = length(unique(DATA$year)),ncol = length(unique(DATA$tac)))
      
      ncvar_put(nc=nc, varid=STOCK, vals=matSTOCK, start = c(1,1,1,1,i,j),  count = c(1,1,-1,-1,1,1))
      ncvar_put(nc=nc, varid=HARVEST, vals=matHARVEST, start = c(1,1,1,1,i,j),  count = c(1,1,-1,-1,1,1))
      
      
      ncvar_put(nc=nc, varid=F0.1, vals=unique(DATA$f0.1), start = c(1,1,i,j),  count = c(1,1,1,1))
      ncvar_put(nc=nc, varid=SSB0.1, vals=unique(DATA$ssb0.1), start = c(1,1,i,j),  count = c(1,1,1,1))
      
    }
  }
  
  nc_close(nc)
  
}


NetCDFProjtoRdata <- function(nc_name,nc_path="/home/taha/R1/monR-2013/esp_travail"){
  
  # nc <- nc_open("data_projection_Run_1_911.nc")
  nc <- nc_open(paste(nc_path,nc_name,sep="/"))
  
  
  Scenario <- nc$dim[["Scenario"]]$vals
  Scenario <- ( c("low","med","high"))
  
  tac <-  nc$dim[["tac"]]$vals
  iter <-  nc$dim[["iter"]]$vals
  year <-  nc$dim[["year"]]$vals
  
  var <- ncvar_get(nc,"stock")
  var <- as.vector(var)
  var2 <- ncvar_get(nc,"harvest")
  var2 <- as.vector(var2)
  tab <- expand.grid(year,tac,iter,Scenario)
  names(tab) <- c("year","tac","iter","Scenario")
  tab <- tab[c("Scenario","tac","iter","year")]
  tab$stock <- var
  tab$harvest <- var2
  
  var3 <- ncvar_get(nc,"f01")
  rownames(var3) <- Scenario
  if(length(nc$dim[["iter"]]$vals)>1){
  colnames(var3) <- nc$dim[["iter"]]$vals}
  var3 <- melt(var3)
  if(length(nc$dim[["iter"]]$vals)>1){
  names(var3) <- c("Scenario","iter","f0.1")
  } else {names(var3) <- c("Scenario","f0.1") ; var3$iter <- nc$dim[["iter"]]$vals}
  tab1 <- merge(tab,var3,by  = c("Scenario","iter"),sort=F)
  
  var4 <- ncvar_get(nc,"ssb01")
  rownames(var4) <- Scenario
  if(length(nc$dim[["iter"]]$vals)>1){
  colnames(var4) <- nc$dim[["iter"]]$vals}
  var4 <- melt(var4)
  if(length(nc$dim[["iter"]]$vals)>1){
  names(var4) <- c("Scenario","iter","ssb0.1")
  } else {names(var4) <- c("Scenario","ssb0.1") ; var4$iter <- nc$dim[["iter"]]$vals}
  tab1 <- merge(tab1,var4,by  = c("Scenario","iter"),sort=F)
  
  tab <-tab1[c("Scenario","tac" ,"iter" , "year", "f0.1","ssb0.1","stock" ,"harvest")] 
   return(tab)
}
