#######################################
### Scripts to run the projections  ###
### For the selected run            ###
#######################################
proj_exe_file2 <- paste(dirVpaFiles,"pro-2box.out", sep="")
source(paste(dirRScripts,"age_plus_conversion.R", sep=""))
### function to calculate standard error
std.err <- function(x) {x <- x[is.na(x)==F]; sd(log(x)-mean(log(x)))}

### function to calculate the CV to apply
cv_recr <- function(){
  # modif: pour lire les retro en ligne a partir des netcdf
  #  load(paste(dirRData, "data_retro_", run_name, "_", abs(seed_numb), ".Rdata", sep=""))
  outputs_VPA <- NetCDFtoRdata(nc_name =paste("data_retro_",run_name,"_",abs(seed_numb),".nc",sep=""),nc_path = URL_executed_Runs )
	    
             low  = std.err(outputs_VPA$main$value[outputs_VPA$main$variable=="Recruits" & outputs_VPA$main$Retros==0 & outputs_VPA$main$Year%in% seq(1970,1980)])
             med  = std.err(outputs_VPA$main$value[outputs_VPA$main$variable=="Recruits" & outputs_VPA$main$Retros==0 & outputs_VPA$main$Year%in% seq(1955,2006)])
             high = std.err(outputs_VPA$main$value[outputs_VPA$main$variable=="Recruits" & outputs_VPA$main$Retros==0 & outputs_VPA$main$Year%in% seq(1990,2000)])
             res <- c(low,med,high)
             return(res)
    }

### function to calculate the geomean to apply for each recruitment scenario
    recruits <- function(scen){
      # modif: pour lire les retro en ligne a partir des netcdf
      #  load(paste(dirRData, "data_retro_", run_name, "_", abs(seed_numb), ".Rdata", sep=""))
      outputs_VPA <- NetCDFtoRdata(nc_name =paste("data_retro_",run_name,"_",abs(seed_numb),".nc",sep=""),nc_path = URL_executed_Runs )
  
        switch(scen,
               low  = geomean_cal(outputs_VPA$main$value[outputs_VPA$main$variable=="Recruits" & outputs_VPA$main$Retros==0 & outputs_VPA$main$Year%in% seq(1970,1980)]),
               med  = geomean_cal(outputs_VPA$main$value[outputs_VPA$main$variable=="Recruits" & outputs_VPA$main$Retros==0 & outputs_VPA$main$Year%in% seq(1955,2006)]),
               high = geomean_cal(outputs_VPA$main$value[outputs_VPA$main$variable=="Recruits" & outputs_VPA$main$Retros==0 & outputs_VPA$main$Year%in% seq(1990,2000)]))
      }
 
####################################################################
### function to create and run a projection for a specific run   ###
####################################################################
creat_proj <- function(run_name, seed_numb, selYear1, selYear2){
  
  runs  <- runParameters[runParameters$Run==run_name,]
  if (length(grep(pattern = runs$CAA, x="CAA_inflated.csv"))==1) {type_rep="Inflated"} else {type_rep = "Reported"}
  dir_proj <- paste(dirOutputs, type_rep, "/", run_name, "/Boot/", abs(seed_numb),sep="")
  if (file.exists(dir_proj)==T) {setwd(dir_proj)} else {stop(paste(dir_proj, " doesn't exist!", sep=""))}
  dir.create("low")
  file.copy(from=dir(), to = paste("low/", dir(), sep=""))
  dir.create("med")
  file.copy(from=dir(), to = paste("med/", dir(), sep=""))
  dir.create("high")
  file.copy(from=dir(), to = paste("high/", dir(), sep=""))
   scen = c("low", "med", "high")
  ### calculate the standard error
   # modif: pour lire les retro en ligne a partir des netcdf
  # load(paste(dirRData, "data_retro_", run_name, "_", abs(seed_numb), ".Rdata", sep=""))
  outputs_VPA <- NetCDFtoRdata(nc_name =paste("data_retro_",run_name,"_",abs(seed_numb),".nc",sep=""),nc_path = URL_executed_Runs )
  
  cv_recruits_1 <- max(cv_recr())
  
  for (i in 1:3){
      dir_proj1 <- paste(dir_proj, "/", scen[i],"/", sep="")
      file_out1 <- paste(dir_proj1, "quotas.txt", sep="")
      write_quotas(file_out      = file_out1,
                   scen_num      = 17, ### !!! 3 are then added for F0.1, FMSY and FMAX
                   area_stock    = 1,
                   fishery       = 1,
                   current_quota = current_quota_1,
                   futur_quotas  = c(seq(0,12000,2000),
                                     current_quota_1,
                                     14000, 15000, seq(16000,30000,2000)),
                   current_F     = 3,
                   futur_F       = 3)
      file_out1 <- paste(dir_proj1, "discards.txt", sep="")  
      years_1   <- c(1950,2013)
      age_plus_2<- 40
      write_disc(file_out    = file_out1,
                 years       = years_1,
                 age_plus    = age_plus_2,
                 v1          = rep(1,length=(years_1[2]-years_1[1]+1)),
                 v2          = rep(1,length=(years_1[2]-years_1[1]+1)),
                 exch        = matrix(0,nrow=(years_1[2]-years_1[1]+1),ncol= age_plus_2) )
    
      file_out1 <- paste(dir_proj1, "Prj10.ctl", sep="")      
      write_prjctlVPA            (file_out           = file_out1,
                                  model_type         = 1,
                                  n_box              = 1,
                                  n_loops            = 1000,
                                  ci                 = 80,
                                  seed               = seed_numb,
                                  patch              = 5,
                                  yr_box             = 1,
                                  sr_box             = 0,
                                  sex_fraction       = 1,
                                  weight_type        = 1,
                                  years              = c(1950,2013,2050),
                                  ages               = c(1,age_plus_1,age_plus_1),
                                  selec_F_years      = c(selYear1, selYear2),
                                  recruit_ssb_years  = c(1990,2004,2000,2004),
                                  err_type_ssb_r     = 1,
                                  n_gears            = 1,
                                  ave_age_plus_group = -40,
                                  maturity=paste(c(0,0,0,0.5,rep(1,36)), sep="\t"),
                                  curve_type=1,
                                  L_inf=318.9,
                                  k=0.093,
                                  t0=-0.97,
                                  Chap_Rich=1,
                                  a_weight=0.0000196,
                                  b_weight=3.0092,
                                  time_growth=6,
                                  offset_vpa=6,
                                  file_types=c(0,1,1,0,0,0,0,0,0,0),
                                  file_names=c("quotas.txt","NAA.OUT","FAA.OUT",
                                                 "waa.txt", "caa.txt","maa.txt",
                                                 "Sel.txt","recruit.txt","Trans.txt",
                                                 "discards.txt") )
      
      file_out1 <- paste(dir_proj1, "Sel.txt", sep="")     
      write_sel           (file_out = file_out1,
                            v1       = c(1,1),
                            v2       = rep(1,40) )
    
      
      file_out1 <- paste(dir_proj1, "recruit.txt", sep="")     
      recr_max <- recruits(scen[i])
      write_recruit(file_out   = file_out1,
                    v1         = 1,
                    v2         = -7,
                    r_max      = recr_max,
                    ssb_param  = 0.,
                    cv_recruit = cv_recruits_1,
                    v3         = 0,
                    v4         = 0)

      file_out1 <- paste(dir_proj1, "caa.txt", sep="")  
      write_caa_txt(file_out   = file_out1,
                    age_plus   = age_plus_1,
		    run_name_caa = run_name
		   )
      
      file_out1 <- paste(dir_proj1, "waa.txt", sep="")  
      write_waa_txt(file_out   = file_out1,
                    age_plus   = age_plus_1,
		    run_name_waa = run_name)

      file_out1 <- paste(dir_proj1, "Trans.txt", sep="")  
      write_trans_txt(dir_out=dir_proj1,
		      file_out   = file_out1) 

     cat("1	0.49	0.24	0.24	0.24	0.24	0.2	0.175	0.15	0.125	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1	0.1", file=paste(dir_proj1,"maa.txt", sep=""), append=F)

     cat("Prj10.ctl", file=paste(dir_proj1,"Prj.txt", sep=""), append=F)   

if (Sys.info()[1]=="Linux")  {projExeFile  <- paste(dirVpaFiles, "pro-2box.out", sep="")
                              file.copy(from=projExeFile, to=dir_proj1, copy.mode = T, overwrite=T)
			      setwd(dir_proj1)
                              system(paste("./pro-2box.out < Prj.txt", sep=" "))
                              # file.remove("vpa-2box.out") # I think it worth it to keep the exe to keep track of what has been used
                              }
#if (Sys.info()[1]=="Windows"){ vpaExeFile  <- paste(dirVpaFiles, "vpa-2box.exe", sep="")
#                               file.copy(from=vpaExeFile, to=dir_proj1)
#                               system(paste("yes | wine vpa-2box.exe", sep=""))
#                              # file.remove("vpa-2box.exe") # I think it worth it to keep the exe to keep track of what has been used
#                              }

      #file.copy(from=proj_exe_file1, to=dir_proj1)
#      file.copy(from=proj_exe_file2, to=dir_proj1)
#      file.copy(from=vpa_exe_file, to=dir_proj1)
      #file.copy(from=waa_file, to=dir_proj1)
      #file.copy(from=caa_file, to=dir_proj1)
      #file.copy(from=trans_file, to=dir_proj1)
      
      #system("wine pro-2box.exe Prj10.ctl")
      #cat(as.character(Sys.time()), i, "over", dim(simulations)[1], sep=" ", file=paste(dir_main, "/loop_number.txt", sep=""), append=(i!=1))
      #file.remove(paste(dir_proj1,proj_exe_file2 , sep=""))
  }
}


save_proj <- function(run_name, seed_numb, selYear1, selYear2 ){
  if (length(grep(pattern = runParameters$CAA[runParameters$Run==run_name], x="CAA_inflated.csv"))==1) {type_rep="Inflated"} else {type_rep = "Reported"}
  dir_projection         <- paste(dirOutputs, type_rep,"/", run_name , "/Boot/", abs(seed_numb), "/", sep="")
  reported_output_proj1  <- get_proj_data(dir_in=dir_projection, scen= c("low", "med", "high"), proxy="f0.1")
  save(reported_output_proj1, file=paste(dirRData, "data_projections_", type_rep, "_", run_name,"_", abs(seed_numb),"_",selYear1, "_", selYear2, ".Rdata", sep=""))
 source(paste(dirRScripts,"projOutput2NetCDF.R",sep=""))
  nmnc <- paste("data_projections_", type_rep, "_", run_name,"_", abs(seed_numb),"_",selYear1, "_", selYear2,".nc", sep="")
  projOutput2NetCDF(dirOut_nc=dirNCData,namenc = nmnc,run_name=run_name,nbr_seed=abs(seed_numb),projOutput_VPA = reported_output_proj1)
   quot <- c(seq(0,12000, by=2000), current_quota_1, 14000,15000, seq(16000,30000, by=2000), "F01", "FMSY", "FMAX")
  ## to remove bad bootstraps
  bads <- scan(paste(dir_projection, "BAD.OUT", sep=""), what="", sep="\n", strip.white=TRUE)
  if (length(bads) > 3){
    bads <- bads[seq(1,length(bads), 2)]
    bads <- data.frame(bads=bads, i=1:length(bads))
    bads <- ddply(bads, .(i), function(x) as.numeric(unlist(strsplit(as.character(x$bads), " "))[1]))$V1
    bads <- bads[-length(bads)]
    reported_output_proj2 <- reported_output_proj1[-which(reported_output_proj1$iter%in%bads),] 
  } else {reported_output_proj2 <- reported_output_proj1}
  save(reported_output_proj2, file=paste(dirRData, "data_projections_badsout_", type_rep, "_", run_name,"_", abs(seed_numb),"_",selYear1, "_", selYear2,".Rdata", sep=""))
  source(paste(dirRScripts,"projOutput2NetCDF.R",sep=""))
  nmnc <- paste("data_projections_badsout_", type_rep, "_", run_name,"_", abs(seed_numb),"_",selYear1, "_", selYear2,".nc", sep="")
  projOutput2NetCDF(dirOut_nc=dirNCData,namenc = nmnc,run_name=run_name,nbr_seed=abs(seed_numb),projOutput_VPA = reported_output_proj2)
  return(reported_output_proj2)
}
