rm(list=ls())
runNumb    <- c("Run_1","Run_2","Run_3")
# runNumb     <- "Run_0"

seedNumb <- -911
filenameVpa <- "bfte2014"
nbRetro <- 5
nbBoot <- 0
######################################
get_all_retros <- "some"
run_to_get <-  c("Run_1","Run_2","Run_3")
# run_to_get     <- "Run_0"
seed_number_to_get <-  911
what_data <- "Retros"
catch_type<- c("Reported", "Inflated")
##################################
# URL <-"/home/taha/Projets/VPA_last/RCharts/"
# repository <-"/home/taha/Projets/VPA_last/RCharts/"

#######################
### LOAD libraries  ###
#######################
require(plyr)
library(reshape)
library(ggplot2)
library(RColorBrewer)
library(lattice)
library(xtable)
library(knitr)
library(FLa4a)
library(kobe)
library(shiny)
library(rCharts)
library(ncdf4)


#dirMain     <- "/home/taha/Projets/VPA_Taha/"
dirMain  <- "/home/gcube/RExperiments/VPAWorkflow/julien/"
dirRScripts <- paste(dirMain, "Rscripts/", sep="")
dirVpaFiles <- paste(dirMain, "vpafiles/", sep="")
dirData     <- paste(dirMain, "data/", sep="")
dirRData    <- paste(dirMain, "Rdata/", sep="")
dirNCData   <- paste(dirMain, "NCData/", sep="")
dirRCharts   <- paste(dirMain, "RCharts/", sep="")
dirOutputs  <- paste(dirMain, "outputs/", sep="")

###########
##########
dir_main <- dirMain
dir_R_scripts <- dirRScripts
dir_vpaFiles <- dirVpaFiles
dir_data     <- dirData
dir_Rdata    <- dirRData
dir_outputs  <- dirOutputs
filename_vpa <- filenameVpa


####
####


######################################################################
##STEP 1: RUN THE VPA FROM SPECIFICATIONS ############################
######################################################################
seed <- as.numeric(seedNumb)
if(is.na(seed)){ran_seed = seedNumb } else {if(seed < 0){seed_numb <- seedNumb} else {nb_seed <- seedNumb}}
rm(seed)
### !!! Modify the run_spec.csv and run_spec.nc file if you want to add a Run !!!
# runParameters <- read.csv(paste(dirData,'run_spec.csv',sep=""))
##ou 
source(paste(dirRScripts,"run_specToNetCDF.R",sep=""))
runParameters <- specNCDF2DataFrame(file_name = 'run_spec.nc',directory = dirNCData)

source(paste(dirRScripts, "run_generator.R", sep=""))
##############################################################################################################
### STEP 2: GET THE VPA OUTPUTS                                                                            ###
##############################################################################################################

source(paste(dirRScripts,"get_runs_functions.R", sep=""))
source(paste(dirRScripts,"get_runs_code.R", sep=""))

##########################################################
######### See an RCharts of selected runs  ###############
##########################################################
source(paste(dirRScripts,"OutputsVPA2NetCDF.R", sep=""))

for(i in 1:length(runNumb)){
  # load(paste(dirRData,"data_retro_",runNumb[i],"_",seed_number_to_get,".Rdata",sep=""))
  outputs_VPA <- NetCDFtoRdata(nc_name =paste("data_retro_",runNumb[i],"_",seed_number_to_get,".nc",sep=""),nc_path = dirNCData )
  main <- outputs_VPA$main
  main <- subset(main,main$Retro==0)
  main$Run_num <- paste(runNumb[i],seed_number_to_get,sep=" ")
  if(i==1){data_main <- main}
  if(i>1){data_main <- rbind(data_main,main)}
}

###rChart
result <- ""
for(vari in unique(data_main$variable)){
  data_main_sub <- subset(data_main,data_main$variable==vari)
  
  h1 <- hPlot(value ~ Year , data = data_main_sub, type = "line", group = "Run_num",title = "East/Med Bluefin tuna stock assessment", subtitle = vari)
  h1$addParams(dom = vari)
  h1$chart(zoomType = "xy")
  h1
  
  name_html <- paste(paste(vari,paste(unique(data_main$Run_num), collapse = ' '),sep="_"),"html",sep=".")
  h1$save(paste(dirRCharts,name_html,sep=""), standalone = TRUE)
  result1 <-  paste(dirRCharts,name_html,sep="")
  result <- paste(result,result1,sep=" #!####!# ")
}


#####################################
### SOURCE PLOT FUNCTION for VPA  ###
#####################################
source(paste(dir_R_scripts, 'plot_input_VPA_function.R', sep=""))
source(paste(dir_R_scripts, 'plot_output_VPA_function.R', sep=""))
load(paste(dir_Rdata,"dir_best.Rdata", sep=""))
load(paste(dir_Rdata,"dir_best_AICc.Rdata", sep=""))
##Parapeters of plots#######
RunToCompare <- c(1,3)
RunForRetros <- c(1,5)
RunForCPUE <- 1
RunForFAA <- 1
##############
######Knitr####
###############
path.in       <- paste(dir_main, 'reports/', sep="")
path.out      <- paste(dir_main, 'reports/', sep="")
#####
file.in <- paste(path.in,'update_report_MyTest.Rnw',sep='')
file.out <- paste(path.out,'update_report_MyTest.tex',sep='')

setwd(path.in)
knit(file.in,file.out)

### Need to run the pdflatex to be sure it is compiled properly
#system(paste("pdflatex ",file.out, sep=""))
#system(paste("pdflatex ",file.out, sep=""))
#system(paste("pdflatex ",file.out, sep=""))

