## server.r
library(shiny)
require(rCharts)
library(plyr)
library(FLCore)
library(reshape)
library(ggplot2)
source(paste(dirRScripts, 'plot_output_VPA_function.R', sep=""))
source(paste(dirRScripts, 'plot_outputs_VPA.R', sep=""))

shinyServer(function(input, output) {
  dir_save  <- dirRData
  data_plot <- reactive({read_data(paste(input$run), input$seed_nb, dir_save=dir_save)})
  #data_runs1 <- data_runs()
  
  output$plots <- renderUI({
    plot_output_list <- lapply(1:4, function(i) {
      plotname <- paste("plot", i, sep="")
      chartOutput(plotname, "highcharts")
    })
    
    # Convert the list to a tagList - this is necessary for the list of items
    # to display properly.
    do.call(tagList, plot_output_list)
  })

  for (i in 1:4) {
    # Need local so that each item gets its own number. Without it, the value
    # of i in the renderPlot() will be the same across all instances, because
    # of when the expression is evaluated.
    local({
      my_i <- i
      plotname <- paste("plot", my_i, sep="")
      
      output[[plotname]] <- renderChart2({
        
        data_plot1 <- data_plot()       
        un <- unique(data_plot1$variable)
        data_sub <- data_plot1[data_plot1$variable==un[my_i] & data_plot1$Retros==0,]
        h1 <- hPlot(value ~ Year , data = data_sub, type = "line", group = "Run_seed", title=as.character(un[my_i]))
        h1$chart(zoomType = "xy")
        h1$exporting(enabled = T)
        #h1$save(paste("titi", my_i, ".html", sep=""))
        #print(str(h1))
        return(h1)
      })
    })
  }

})