## ui.R
library(shiny)
library(plyr)
require(rCharts)
library(FLCore)
library(reshape)
library(ggplot2)


run_parameters <- read.csv(paste(dirData, "run_spec.csv", sep=""))
### load the seed number
load(paste(dirRData, "seed_number.Rdata", sep=""))
seed_nb <- seeds

shinyUI(pageWithSidebar(
  headerPanel("rCharts - R Shiny application for East/Med Bluefin tuna stock assessment"),
  
  sidebarPanel(
    selectInput(inputId = "mode",
                label = "Plot one specific run or several runs",
                choices = c('One run', 'Several'),
                selected = "Several"
                ),
    
    conditionalPanel(condition  = "input.mode == 'Several'",
        selectizeInput(inputId  = 'run',
                       label    = 'Choose the run(s) to plot',
                       choices  = as.character(run_parameters$Run),
                       selected = c(as.character(run_parameters$Run)[1],as.character(run_parameters$Run)[run_parameters$Run=="Run_7"]),
                       multiple = TRUE
                       ),
        selectizeInput(inputId  = 'seed_nb',
                       label    = 'Choose the seed number(s)',
                       choices  = seed_nb ,
                       selected = seed_nb[1],
                       multiple = TRUE
                       )

                    ),

    conditionalPanel(condition  = "input.mode == 'One run'",
        selectInput(   inputId  = 'run',
                       label    = 'Choose the run to plot',
                       choices  = as.character(run_parameters$Run),
                       selected = as.character(run_parameters$Run)[1]
                   ),
        selectInput(   inputId  = 'seed_nb',
                       label    = 'Choose the seed number',
                       choices  = seed_nb ,
                       selected = seed_nb[1]
                   )
                   )
),
  mainPanel(
    #TextOutput('ex_out1'),
    #plotOutput("myplot")
      #verbatimTextOutput('ex_out')
    uiOutput("plots")
    #showOutput("SSB", "highcharts")
    #showOutput("Recruits", "highcharts"),
    #showOutput("F25", "highcharts"),
    #showOutput("F10", "highcharts")
  )
))