#52North WPS annotations
# wps.des: id = VPA_ICCAT_BFT-E, title = ICCAT (Eastern) Bluefin Tuna Stock Assessment, abstract = this set of R and Fortran code have been provided by ICCAT and IFremer to execute the whole Stock assessment workflow online, integration has been don with the help (mediation) of CNR and IRD;

# wps.in: id = runNumb, type = string, title = Select Runs (one or more) you want to run from the run_spec.csv file (to run them all type "all" ), value = "Run_1,Run2,Run3";
# wps.in: id = seedNumb, type = string, title = Select the seeds to use for the run (should be negative integer to select a seed number or positive integer to specify a number of random seed or string (the Rdata filename) to use the random seeds used previously, value = "-911";
# wps.in: id = filenameVpa, type = string, title = Define file names for the vpa, value = "bfte2014";
# wps.in: id = nbRetro, type = Integer, title =Select the number of retrosspective analyses to be done (you cannot make bootstraps and retros at the  time), value = "5";
# wps.in: id = nbBoot, type = Integer, title =Select the number of bootstraps analyses to be done (you cannot make bootstraps and retros at the  time), value = "0";
# wps.in: id = get_all_retros, type = String, title = Define from which run you want to get the data either one specific or "different"some" runs or "all" to get all retros, value = "some";
# wps.in: id = run_to_get, type = String, title = , value = "Run_1,Run2,Run3";
# wps.in: id = seed_number_to_get, type = Integer, title =, value = "911";
# wps.in: id = what_data, type = String, title ="Retros" or "Projection" =, value = "Retros";
# wps.in: id = catch_type, type = String, title ="Reported|Inflated", value = "Reported";


# wps.in: id = Outputs_type, type = string, title = type of outputs (PDF|HTML|NETCDF) , value = "PDF";
# wps.out: id = res, type = string, title = List of result files path ;

###evaluate WPS Parameters with more than one value### Que pour la version WPS

# runNumb <- unlist(strsplit(runNumb,split = ","))
# seedNumb <- as.numeric(unlist(strsplit(seedNumb,split = ",")))
# run_to_get <- unlist(strsplit(run_to_get,split = ","))
# seed_number_to_get <- as.numeric(unlist(strsplit(seed_number_to_get,split = ",")))
# Outputs_type <- unlist(strsplit(Outputs_type,split = ","))

# 
# ######### test of WPS in R
# ##########################################
# 
rm(list=ls())
# runNumb    <- c("Run_1","Run_2","Run_3")
runNumb     <- "Run_1"

seedNumb <- -912
filenameVpa <- "bfte2014"
nbRetro <- 5
nbBoot <- 0
######################################
get_all_retros <- "some"
# run_to_get <-  c("Run_1","Run_2","Run_3")
run_to_get     <- "Run_1"
seed_number_to_get <-  912
what_data <- "Retros"
catch_type<- c("Reported", "Inflated")
################################


#######################
### LOAD libraries  ###
#######################
require(plyr)
library(reshape)
library(ggplot2)
library(RColorBrewer)
library(lattice)
library(xtable)
library(knitr)
library(FLa4a)
library(kobe)
library(shiny)
library(rCharts)
library(ncdf4)


# dirMain     <- "/home/gcube/RExperiments/VPAWorkflow/julien/"
dirMain     <- "/data/julien/"

dirRScripts <- paste(dirMain, "Rscripts/", sep="")
dirVpaFiles <- paste(dirMain, "vpafiles/", sep="")
dirData     <- paste(dirMain, "data/", sep="")
dirRData    <- paste(dirMain, "Rdata/", sep="")
dirNCData   <- paste(dirMain, "NCData/", sep="")
dirRCharts   <- paste(dirMain, "RCharts/", sep="")
dirOutputs  <- paste(dirMain, "outputs/", sep="")

###########
##########
dir_main <- dirMain
dir_R_scripts <- dirRScripts
dir_vpaFiles <- dirVpaFiles
dir_data     <- dirData
dir_Rdata    <- dirRData
dir_outputs  <- dirOutputs
filename_vpa <- filenameVpa


####
####


######################################################################
##STEP 1: RUN THE VPA FROM SPECIFICATIONS ############################
######################################################################
  seed <- as.numeric(seedNumb)
  if(is.na(seed)){ran_seed = seedNumb } else {if(seed < 0){seed_numb <- seedNumb} else {nb_seed <- seedNumb}}
  rm(seed)
  ### !!! Modify the run_spec.csv and run_spec.nc file if you want to add a Run !!!
  # runParameters <- read.csv(paste(dirData,'run_spec.csv',sep=""))
  ##ou 
  source(paste(dirRScripts,"run_specToNetCDF.R",sep=""))
  runParameters <- specNCDF2DataFrame(file_name = 'run_spec.nc',directory = dirNCData)
  
  source(paste(dirRScripts, "run_generator.R", sep=""))
  ##############################################################################################################
  ### STEP 2: GET THE VPA OUTPUTS                                                                            ###
  ##############################################################################################################
  
  source(paste(dirRScripts,"get_runs_functions.R", sep=""))
  source(paste(dirRScripts,"get_runs_code.R", sep=""))

##########################################################
######### See an RCharts of selected runs  ###############
##########################################################
source(paste(dirRScripts,"OutputsVPA2NetCDF.R", sep=""))

for(i in 1:length(runNumb)){
  # load(paste(dirRData,"data_retro_",runNumb[i],"_",seed_number_to_get,".Rdata",sep=""))
  outputs_VPA <- NetCDFtoRdata(nc_name =paste("data_retro_",runNumb[i],"_",seed_number_to_get,".nc",sep=""),nc_path = dirNCData )
  main <- outputs_VPA$main
  main <- subset(main,main$Retro==0)
  main$Run_num <- paste(runNumb[i],seed_number_to_get,sep=" ")
  if(i==1){data_main <- main}
  if(i>1){data_main <- rbind(data_main,main)}
}

###rChart
result <- ""
for(vari in unique(data_main$variable)){
  data_main_sub <- subset(data_main,data_main$variable==vari)
  
  h1 <- hPlot(value ~ Year , data = data_main_sub, type = "line", group = "Run_num",title = "East/Med Bluefin tuna stock assessment", subtitle = vari)
  h1$addParams(dom = vari)
  h1$chart(zoomType = "xy")
  h1
  
  name_html <- paste(paste(vari,paste(unique(data_main$Run_num), collapse = ' '),sep="_"),"html",sep=".")
  h1$save(paste(dirRCharts,name_html,sep=""), standalone = TRUE)
  result1 <-  paste(dirRCharts,name_html,sep="")
  result <- paste(result,result1,sep=" #!####!# ")
}

##############################################################################################################
### STEP 3: RUN THE PROJECTIONS ON THE SEKECTED MODEL                                                      ###
##############################################################################################################

##########################################################
#### Bootstraps the selected run(s)                   ###
#### (from the "run_spec.csv" file)                    ###
#### to run them all, type "all"                       ###
##########################################################
### Selected run(s)
#Examples:
runNumb     <- "Run_2"
filenameVpa  <- "bfte2014"
seed_numb   <- -911
nbBoot      <- 10
nbRetro     <- 0

timeTestStart <- Sys.time()
source(paste(dirRScripts, "run_generator.R", sep=""))
timeTestEnd <- Sys.time()
timeTestEnd-timeTestStart

# Projections
run_name1 <- "Run_2"
seed_numb <- -911
current_quota_1 <- 13500


source(paste(dirRScripts, "writeFuncs_proj.R", sep=""))

timeTestStart <- Sys.time()
source(paste(dirRScripts, "proj_creator.R", sep=""))
timeTestEnd <- Sys.time()
timeTestEnd-timeTestStart
#####################################
### SOURCE PLOT FUNCTION for VPA  ###
#####################################
source(paste(dir_R_scripts, 'plot_input_VPA_function.R', sep=""))
source(paste(dir_R_scripts, 'plot_output_VPA_function.R', sep=""))
load(paste(dir_Rdata,"dir_best.Rdata", sep=""))
load(paste(dir_Rdata,"dir_best_AICc.Rdata", sep=""))
##Parapeters of plots#######
RunToCompare <- c(1,3)
RunForRetros <- c(1,5)
RunForCPUE <- 1
RunForFAA <- 1
##############
######Knitr####
###############
path.in       <- paste(dir_main, 'reports/', sep="")
path.out      <- paste(dir_main, 'reports/', sep="")
#####
file.in <- paste(path.in,'update_report_MyTest.Rnw',sep='')
file.out <- paste(path.out,'update_report_MyTest.tex',sep='')

setwd(path.in)
knit(file.in,file.out)

### Need to run the pdflatex to be sure it is compiled properly
system(paste("pdflatex ",file.out, sep=""))
system(paste("pdflatex ",file.out, sep=""))
system(paste("pdflatex ",file.out, sep=""))

# ##pour la sortie du WPS # version WPS
# res <- ""
# if("PDF" %in% Outputs_type){res1 <- paste(path.out,'update_report_MyTest.pdf',sep='');res <- paste(res,res1,sep=" #!####!# ")}
# if("HTML" %in% Outputs_type){res1 <- result;res <- paste(res,res1,sep=" #!####!# ")}
# if("HTML" %in% Outputs_type){res1 <- result;res <- paste(res,res1,sep=" #!####!# ")}
# if("NETCDF" %in% Outputs_type){
#   res1 <- paste(paste(paste(dirNCData,"data_retro_",run_to_get,"_",seed_number_to_get,".nc",sep="")),collapse = " #!####!# ")
#   res <- paste(res,res1,sep=" #!####!#  #!####!# ")
# }



